<?php
namespace app\admin\controller;

use app\admin\model\ActionLog;
use app\admin\model\GoodLog;
use app\admin\model\ProcessOrder;
use app\BaseController;
use think\facade\Db;
use think\App;
class Purchin extends BaseController
{
    public $post="";
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->post=$this->request->post();

    }

    public  function  list(){
        $page = isset($this->post['page']) && $this->post['page'] !==""? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !==""? intval($this->post['size']):"10";
        $where =[['a.is_del',"=",0],['b.is_del',"=",0]];
        $wsm_in_code=isset($this->post['wsm_in_code']) && $this->post['wsm_in_code']!==""? trim($this->post['wsm_in_code']) :"";
        if($wsm_in_code!=""){
            $where[]=["a.wsm_in_code",'like',"%$wsm_in_code%"];
        }
        $cgdNo= isset($this->post['cgdNo']) && $this->post['cgdNo'] !==""? trim($this->post['cgdNo']) :"";
        if($cgdNo!=""){
            $where[]=['a.cgdNo','like',"%$cgdNo%"];
        }
        $apply_name = isset($this->post['apply_name']) && $this->post['apply_name'] !==""? trim($this->post['apply_name']):"";
        if($apply_name!=""){
            $where[]=['a.apply_name','like',"%$apply_name%"];
        }
        $apply_id= isset($this->post['apply_id']) && $this->post['apply_id'] !==""? trim($this->post['apply_id']):"";
        if($apply_id!=""){
            $where[]=['a.apply_id','=',$apply_id];
        }
        $status= isset($this->post['status']) && $this->post['status'] !==""? trim($this->post['status']):"";
        if($status!=""){
            $where[]=['a.status','=',$status];
        }
        $start= isset($this->post['start']) && $this->post['start'] !== "" ? $this->post['start']:"";
        if ($start !="") {
            $where[]= ["a.sendtime",'>=',$start];
        }
        $end = isset($this->post['end']) && $this->post['end'] !== "" ? $this->post['end'] :"";
        if($end !=""){
            $where[]= ["a.sendtime",'<=',$end];
        }
        $order_type=isset($this->post['order_type']) && $this->post['order_type']!==""? intval($this->post['order_type']):"";
        if($order_type !=""){
            $where[]= ["b.order_type",'=',$order_type];
        }
        $good_type_code=isset($this->post['good_type_code']) && $this->post['good_type_code']!==""? trim($this->post['good_type_code']):"";
        if($good_type_code !=""){
            $where[]= ["b.spuCode",'like',"%$good_type_code%"];
        }
        $good_name=isset($this->post['good_name']) && $this->post['good_name']!==""? trim($this->post['good_name']):"";
        if($good_name !=""){
            $where[]= ["b.good_name",'like',"%$good_name%"];
        }
        $supplie=isset($this->post['supplier']) && $this->post['supplier']!==""? trim($this->post['supplier']):"";
        if($supplie !=""){
            $where[]= ["b.supplierNo",'like',"%$supplie%"];
        }
        $wsm_code=isset($this->post['wsm_code']) && $this->post['wsm_code']!==""? trim($this->post['wsm_code']):"";
        if($wsm_code !=""){
            $where[]= ["a.wsm_code",'=',$wsm_code];
        }
        $supplierNo =isset($this->post['supplierNo']) &&$this->post['supplierNo'] !=="" ? trim($this->post['supplierNo']):"";
        if($supplierNo!=""){
            $supplier = Db::name("supplier")->where(["code"=>$supplierNo])->find();
            if(empty($supplier)){
                return error_show(1004,"未找到供应商信息");
            }
            $wsmcode = Db::name("warehouse_info")->where([
                "is_del"=>0,"supplierNo"=>$supplierNo])->column("wsm_code");
            $where[]=['a.wsm_code',"in",$wsmcode];
        }
        $count = Db::name('purchease_in')->alias('a')->join("purchease_order b","b.cgdNo=a.cgdNo","left")
            ->where($where)->count();
        $total = ceil($count/$size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('purchease_in')->alias('a')->join("purchease_order b","b.cgdNo=a.cgdNo","left")
            ->where($where)->page($page,$size)
            ->field("a.apply_name,a.sendtime,b.order_type,a.status,a.cgdNo,a.wsm_in_code,a.send_num,a.wsm_code,b.good_name,b.spuCode,
            a.post_company,a.post_code,a.post_fee,a.apply_id,a.wsm_num,a.error_num,a.wait_num,a.status,a.check_name,a.checkid,b.bkcode,b.supplierNo")
            ->order("a.addtime desc")->select();
        $data=[];
        foreach ($list as $value){

            //获取规格、品牌信息
            if ($value['order_type'] == 3 || $value['order_type'] == 4) {
                $temp = Db::name('good_zixun')
                    ->alias('gz')
                    ->field('gz.specinfo,b.brand_name')
                    ->join('brand b', 'b.id=gz.brand_id')
                    ->where(['gz.spuCode' => $value['spuCode'], 'gz.is_del' => 0])
                    ->find();
                $value["brand_name"] = $temp['brand_name'];
                $value["speclist"] = json_decode($temp['specinfo'], true);

            } else {
                $value['brand_name'] = Db::name('good_basic')
                    ->alias('gb')
                    ->join('brand b', 'b.id=gb.brand_id')
                    ->where(['gb.spuCode' => $value['spuCode']])
                    ->value('b.brand_name');

                $spec = Db::name("good_spec")
                    ->where(["spuCode" => $value['spuCode'], "is_del" => 0])
                    ->select()
                    ->toArray();
                $speclist = [];
                if (!empty($spec)) {
                    foreach ($spec as $val) {
                        $temp = [];
                        $temp['id'] = $val['id'];
                        $temp['spuCode'] = $val['spuCode'];
                        $temp['spec_id'] = $val['spec_id'];
                        $temp['spec_value_id'] = $val['spec_value_id'];
                        $sp = Db::name("specs")->where(["id" => $val['spec_id']])->find();
                        $temp['spec_name'] = isset($sp["spec_name"]) ? $sp["spec_name"] : "";
                        $spv = Db::name("spec_value")->where(["id" => $val['spec_value_id']])->find();
                        $temp['spec_value'] = isset($spv["spec_value"]) ? $spv["spec_value"] : "";
                        $speclist[] = $temp;
                    }
                }
                $value["speclist"] = empty($speclist) ? [] : $speclist;
            }


            $wsmcode = Db::name("warehouse_info")->alias("k")->leftJoin("supplier c","k.supplierNo=c.code")
                ->where(["k.wsm_code"=>$value['wsm_code']])->field("k.name as wsm_name,c.name,c.code")->find();
            $value['wsm_name'] = $wsmcode['wsm_name'];
            $value['wsm_supplier'] = $wsmcode['name'];
            $value['wsm_supplierNo'] = $wsmcode['code'];
            $data[]=$value;
        }
        return app_show(0,"获取成功",['list'=>$data,'count'=>$count]);
    }
    public function  add(){
        $cgdNo = isset($this->post['cgdNo']) && $this->post['cgdNo']!=""? trim($this->post['cgdNo']):"";
        if($cgdNo==""){
            return error_show(1005,"参数cgdNo 不能为空");
        }
        $cgdinfo = Db::name("purchease_order")->where(['cgdNo'=>$cgdNo,'is_del'=>0])->find();
        if(empty($cgdinfo)){
            return error_show(1005,"未找到采购单数据");
        }
       if($cgdinfo['status']==0){
           return error_show(1005,"采购单未发货");
       }

        $wsm_in_code = makeNo("IC");
//       $wsm_code = isset($this->post['wsm_code'])&&$this->post['wsm_code']!="" ? trim($this->post['wsm_code']):"";
//       if($wsm_code==""){
//           return error_show(1004,"参数 wsm_code 不能为空");
//       }
       $wsminfo = Db::name("warehouse_info")->where(["wsm_code"=>$cgdinfo['wsm_code'],"is_del"=>0])->find();
       if(empty($wsminfo)){
           return error_show(1004,"未找到仓库信息");
       }
       $recep = Db::name('warehouse_addr')->where(["wsm_code"=>$cgdinfo['wsm_code'],"is_del"=>0])->find();

        $sendtype = isset($this->post['sendtype'])&&$this->post['sendtype']!="" ? intval($this->post['sendtype']):"";
        if($sendtype==""){
            return error_show(1004,"参数 sendtype 不能为空");
        }

        $data = GetUserInfo($this->post['token']);
        if((!empty($data) && $data['code']!=0) ||empty($data) ){
            return error_show($data['code'],$data['message']);
        }
        $userinfo = $data['data'];
        $post_company = isset($this->post['post_company'])&&$this->post['post_company']!="" ? trim($this->post['post_company']):"";
        $post_code = isset($this->post['post_code'])&&$this->post['post_code']!="" ? trim($this->post['post_code']):"";
        $post_fee = isset($this->post['post_fee'])&&$this->post['post_fee']!="" ? $this->post['post_fee']:"0";
        $post_time = isset($this->post['post_time'])&&$this->post['post_time']!="" ? $this->post['post_time']:date("Y-m-d H:i:s");
        $send_num = isset($this->post['send_num'])&&$this->post['send_num']!="" ? intval($this->post['send_num']):"";
        $status = isset($this->post['status'])&&$this->post['status']!="" ? intval($this->post['status']):"1 ";
        if($send_num==''){
            return error_show(1004,"参数 send_num 不能为空或零");
        }
        if($send_num>$cgdinfo['wsend_num']){
            return error_show(1009,"采购单剩余未发货数量不足");
        }
        if($cgdinfo['order_type']==1||$cgdinfo['order_type']==2 ){
            $goodinfo = Db::name("good")->where(["spuCode"=>$cgdinfo['spuCode'],"is_del"=>0])->find();
            if($goodinfo==false){
                return error_show(1004,"商品数据未找到");
            }
            if($goodinfo['is_stock']==0){
                $status=4;
            }
        }
        $orin = [
            "wsm_in_code"=>$wsm_in_code,
            "cgdNo"=>$cgdNo,
            "wsm_code"=>$cgdinfo['wsm_code'],
            "wsm_reaper"=>isset($recep)&& $recep['wsm_name']!=''? $recep['wsm_name']:"",
            "send_num"=>$send_num,
            "post_company"=>$post_company,
            "post_code"=>$post_code,
            "post_fee"=>$post_fee,
            "sendtime"=>$post_time,
            "apply_id"=>$userinfo['id'],
            "apply_name"=>$userinfo['nickname'],
            "wait_num"=>0,
            "sendtype"=>$sendtype,
            "status"=>$status,
            "addtime"=>date("Y-m-d H:i:s"),
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        Db::startTrans();
        try{
            $win = Db::name("purchease_in")->insert($orin,true);
            $sto = ["order_code"=>$wsm_in_code,"status"=>$status,"action_remark"=>'',"action_type"=>"edit"];
            ActionLog::logAdd($this->post['token'],$sto,"RKD",$status,$sto);
            $process=["order_code"=>$wsm_in_code,"order_id"=>$win,"order_status"=>$status,"order_type"=>'RKD'];
            ProcessOrder::AddProcess($this->post['token'],$process);
            if($win){
                $order = ["order_code"=>$wsm_in_code,"status"=>$status,"action_remark"=>'',"action_type"=>"create"];
                ActionLog::logAdd($this->post['token'],$order,"rkd",$status,$this->post);
                if($status==1){
                    $order = ["order_code"=>$cgdNo,"status"=>$cgdinfo['status'],"action_remark"=>'',"action_type"=>"edit"];
                    ActionLog::logAdd($this->post['token'],$order,"CGD", $cgdinfo['status'],$cgdinfo);
                    $cgdinfo['wsend_num']-=$send_num;
                    $cgdinfo['send_num']+=$send_num;
                    $cgdinfo['send_status']=$cgdinfo['wsend_num']==0 ? 3:($cgdinfo['send_num']==0 ?1:2);
                    $cgdinfo['status']=$cgdinfo['wsend_num']==0 ? 3:($cgdinfo['send_num']==0 ?1:2);
                    $cgdinfo['updatetime']=date("Y-m-d H:i:s");
                    $up=Db::name("purchease_order")->save($cgdinfo);
                    if($up){
                            $process=["order_code"=>$cgdNo,"order_id"=>$cgdinfo['id'],"order_status"=>$cgdinfo['status'],"order_type"=>'CGD'];
                            ProcessOrder::AddProcess($this->post['token'],$process);
                            Db::commit();
                            return app_show(0,'新建成功',["wsm_in_code"=>$wsm_in_code]);
                    }else{
                        Db::rollback();
                        return error_show(1004,"新建失败");
                    }
                }
                if($status==4){
                    $cgdinfo['wsend_num']-=$send_num;
                    $cgdinfo['send_num']+=$send_num;
                    $cgdinfo['send_status']=$cgdinfo['wsend_num']==0 ? 3:($cgdinfo['send_num']==0 ?1:2);
                    $cgdinfo['status']=$cgdinfo['wsend_num']==0 ? 3:($cgdinfo['send_num']==0 ?1:2);
                    $cgdinfo['updatetime']=date("Y-m-d H:i:s");
                    $up=Db::name("purchease_order")->save($cgdinfo);
                    if($up==false){
                        Db::rollback();
                        return error_show(1004,"新建失败");
                    }
                    $order = ["order_code"=>$cgdNo,"status"=>$cgdinfo['status'],"action_remark"=>'',"action_type"=>"edit"];
                    ActionLog::logAdd($this->post['token'],$order,"CGD", $cgdinfo['status'],$cgdinfo);
                    $process=["order_code"=>$cgdNo,"order_id"=>$cgdinfo['id'],"order_status"=>$cgdinfo['status'],"order_type"=>'CGD'];
                    ProcessOrder::AddProcess($this->post['token'],$process);
                    $good = Db::name("good_stock")->where(["wsm_code"=>$cgdinfo['wsm_code'],
                        "spuCode"=>$cgdinfo['spuCode'],"is_del"=>0])->find();
                    if(empty($good)) {
                        $good=[
                            "spuCode"=>$cgdinfo['spuCode'],
                            "wsm_code"=>$cgdinfo['wsm_code'],
                            "usable_stock"=>0,
                            "wait_out_stock"=>0,
                            "wait_in_stock"=>0,
                            "total_stock"=>0,
                            "addtime"=>date("Y-m-d H:i:s"),
                            "updatetime"=>date("Y-m-d H:i:s"),
                        ];
                        $order = ["order_code"=>$good['spuCode'],"status"=>1,"action_remark"=>'',
                            "action_type"=>"create"];

                    }else{
                        $order = ["order_code"=>$good['spuCode'],"status"=>1,"action_remark"=>'', "action_type"=>"edit"];
                    }
                    $good['usable_stock']+=$send_num;
                    $good['wait_in_stock']-=$send_num;
                    $good['total_stock']=$good['usable_stock']+$good['wait_out_stock'];
                    $good['updatetime'] = date("Y-m-d H:i:s");
                    $upd=  Db::name("good_stock")->save($good);
                    $good_data[]=["stock_id"=>isset($good['id'])? $good['id']:Db::name("good_stock")->getLastInsID(),"type"=>1,
                        'stock'=>$send_num,"stock_name"=>"usable_stock"];
                    if($upd){
                        GoodLog::LogAdd($this->post['token'],$good_data,'入库单');
                        ActionLog::logAdd($this->post['token'],$order,"仓库库存", 1,$good  );
                        Db::commit();
                        return app_show(0,'商品入库成功',["wsm_in_code"=>$wsm_in_code]);
                    }else{
                        Db::rollback();
                        return error_show(1002,"商品入库失败");
                    }
                }
                Db::commit();
                return app_show(0,'新建成功',["wsm_in_code"=>$wsm_in_code]);
            }
            Db::rollback();
            return error_show(1004,"新建失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004, $e->getMessage() . '|' . $e->getFile() . '|' . $e->getLine());
        }
    }

    public function info(){
        $incode = isset($this->post['wsm_in_code'])&&$this->post['wsm_in_code']!="" ? trim($this->post['wsm_in_code']) :"";
        if($incode==""){
            return error_show(1004,"参数wsm_in_code 不为空");
        }
        $info = Db::name("purchease_in")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1004,"未找到数据");
        }
        $dom = Db::name("purchease_order")->where(['cgdNo'=>$info['cgdNo'],'is_del'=>0])->find();
        if($dom['order_type']==3|| $dom['order_type']==4){
            $goon = Db::name("good_zixun")->where(["spuCode"=>$dom['spuCode'],"is_del"=>0])->find();
        }else {
            $goon =Db::name('good_basic')->where(['spuCode'=>$dom['spuCode']])->find();
        }
        if(empty($goon)){
            return error_show(1002,"未找到商品数据");
        }
            $cat= isset($goon['cat_id']) && $goon['cat_id'] !=0 ? made($goon['cat_id']):[];
        $info['cgder']=$dom['cgder'];
        $info['spuCode']=$dom['spuCode'];
        $info['good_name']=$dom['good_name'];
        $info['skuCode']=$dom['skuCode'];
        $info['good_num']=$dom['good_num'];
        $info['good_price']=$dom['good_price'];
        $info['total_fee']=$dom['total_fee'];
        $info['diff_fee']=$dom['diff_fee'];
        $info['diff_weight']=$dom['diff_weight'];
        $info['gold_price']=$dom['gold_price'];
        $wsmcode = Db::name("warehouse_info")->alias("a")->leftJoin("supplier b","a.supplierNo=b.code")
            ->leftJoin("warehouse_addr c","a.wsm_code=c.wsm_code and c.is_del=0")
            ->where(["a.wsm_code"=>$info['wsm_code']])->field("a.name as wsm_name,b.name,b.code,c.wsm_name as wsm_contactor,c.wsm_mobile,c.wsm_addr,c.addr_code")->find();
        $info['wsm_name'] =isset($wsmcode['wsm_name']) ? $wsmcode['wsm_name']:"";
        $info['wsm_supplier'] =isset($wsmcode['name']) ? $wsmcode['name']:"";
        $info['wsm_supplierNo'] =isset($wsmcode['code']) ? $wsmcode['code']:"";
        $info['wsm_contactor'] =isset($wsmcode['wsm_contactor']) ? $wsmcode['wsm_contactor']:"";
        $info['wsm_mobile'] =isset($wsmcode['wsm_mobile']) ? $wsmcode['wsm_mobile']:"";
        $info['addr_code'] =isset($wsmcode['addr_code']) ? $wsmcode['addr_code']:"";
        $info['wsm_addr'] =isset($wsmcode['addr_code']) ? GetAddr($wsmcode['addr_code']):"";
        $info['wsm_addr'].=isset($wsmcode['wsm_addr']) ? $wsmcode['wsm_addr']:"";
        $check = Db::name("purchease_info")->alias("a")->leftJoin("result_info b","a.error_code=b.result_code")->where
        (['wsm_in_code'=>$incode,"a.is_del"=>0])->field("a.id,a.wsm_in_code,a.num,a.error_code,b.result as error_msg,a.error_img,remark,a.is_del")->select();
        $info['checkinfo']= $check;
        $return = Db::name("purchease_return")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
        $return['return_contactor']=isset($return['return_contactor'])&&$return['return_contactor']!="" ?$return['return_contactor']:$info['wsm_contactor'];
        $return['return_addr']=isset($return['return_addr'])&&$return['return_addr']!="" ?$return['return_addr']:$info['wsm_addr'];
        $return['return_mobile']=isset($return['return_mobile'])&&$return['return_mobile']!="" ?$return['return_mobile']:$info['wsm_mobile'];
        $info['return']= $return;
        $info['can']=$cat;
        if(isset($dom['companyNo'])&&$dom['companyNo']!=""){
            $company = Db::name("business")->where(["companyNo"=>$dom['companyNo']])->find();
        }
        $info['company'] = isset($company['company'])?$company['company']:"";
        $info['companyNo'] = isset($dom['companyNo'])?$dom['companyNo']:"";
        $info['order_type'] = isset($dom['order_type'])?$dom['order_type']:"";
        return app_show(0,'获取成功',$info);
    }

    public function check(){
        $incode = isset($this->post['wsm_in_code'])&&$this->post['wsm_in_code']!="" ? trim($this->post['wsm_in_code']) :"";
        if($incode==""){
            return error_show(1004,"参数wsm_in_code 不为空");
        }
        $info = Db::name("purchease_in")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1004,"未找到数据");
        }
        if($info['status']!=1){
            return error_show(1004,"发货单状态有误");
        }
        $order_num = isset($this->post['order_num']) && $this->post['order_num']!==''?intval($this->post['order_num'])
            :"";
        if($order_num===""){
            return error_show(1004,"参数 order_num 不为空");
        }
        $error_list = isset($this->post['error_list']) && $this->post['error_list']!==''?$this->post['error_list']:"";
        $result = GetUserInfo($this->post['token']);
        if((!empty($result) && $result['code']!=0) ||empty($result) ){
            return error_show($result['code'],$result['message']);
        }
        $userinfo = $result['data'];
        Db::startTrans();
        try{
            $order = ["order_code"=>$incode,"status"=>$info['status'],"action_remark"=>'',"action_type"=>"edit"];
            $info['wsm_num'] = $order_num;
            $info['wait_num'] = $info['send_num'];
            $info['checkid'] = $userinfo['id'];
            $info['check_name'] = $userinfo['nickname'];
            $info['status'] =2;
            $info['error_num'] = $info['send_num']-$order_num;
            $info['updatetime'] = date("Y-m-d H:i:s");
            $up =Db::name("purchease_in")->save($info);
            if($up){
                ActionLog::logAdd($this->post['token'],$order,"rkd",2,$this->post);
                $process=["order_code"=>$info['wsm_in_code'],"order_id"=>$info['id'],"order_status"=>$info['status'],"order_type"=>'RKD'];
                ProcessOrder::AddProcess($this->post['token'],$process);
                if(!empty($error_list)){
                    $data=[];
                    foreach ($error_list as $value ){
                        $temp=[];
                        $temp['wsm_in_code']=$info['wsm_in_code'];
                        $temp['num']=$value['num'];
                        $temp['error_code']=$value['error_code'];
                        $temp['error_img']=$value['error_img'];
                        $temp['remark']=$value['remark'];
                        $temp['is_del']=0;
                        $temp['addtime']=date("Y-m-d H:i:s");
                        $temp['updatetime']=date("Y-m-d H:i:s");
                        $data[]=$temp;
                    }
                    $derr= Db::name("purchease_info")->insertAll($data);
                    if($derr){
                        Db::commit();
                        return app_show(0,"验货完成");
                    }else{
                        Db::rollback();
                        return error_show(1002,"验货数据保存失败");
                    }
                }
                Db::commit();
                return app_show(0,"验货完成");
            }
            Db::rollback();
            return error_show(1002,"验货数据保存失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1002,$e->getMessage());
        }
    }

    public function  status(){
        $incode = isset($this->post['wsm_in_code'])&&$this->post['wsm_in_code']!="" ? trim($this->post['wsm_in_code']) :"";
        if($incode==""){
            return error_show(1004,"参数wsm_in_code 不为空");
        }
        $info = Db::name("purchease_in")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1004,"未找到数据");
        }
        $status = isset($this->post['status'])&&$this->post['status']!=="" ? intval($this->post['status']):"";
        if($status===""){
            return error_show(1004,"参数status 不为空");
        }
        if($info['status']==4){
            return error_show(1004,"入库单已完成");
        }
        $remark = isset($this->post['remark'])&&$this->post['remark']!="" ? trim($this->post['remark']) :"";
        Db::startTrans();
        try{
            $order = ["order_code"=>$incode,"status"=>$info['status'],"action_remark"=>'',"action_type"=>"status"];
            $info['status'] = $status;
            $info['remark'] = $remark;
            $info['updatetime'] = date("Y-m-d H:i:s");
            $update = Db::name("purchease_in")->save($info);
            if($update){
                ActionLog::logAdd($this->post['token'],$order,"入库单",$status,$this->post);
                $process=["order_code"=>$info['wsm_in_code'],"order_id"=>$info['id'],"order_status"=>$status,"order_type"=>'RKD'];
                ProcessOrder::AddProcess($this->post['token'],$process);
                if($status==0){
                    $cgdinfo=Db::name("purchease_order")->where(['cgdNo'=>$info['cgdNo'],"is_del"=>0])->find();
                    if(empty($cgdinfo)){
                        Db::rollback();
                        return error_show(1002,"未找到采购单数据");
                    }
                    $order = ["order_code"=>$info['cgdNo'],"status"=>$cgdinfo['status'],"action_remark"=>'',"action_type"=>"edit"];
                    $cgdinfo['wsend_num']+=$info['send_num'];
                    $cgdinfo['send_num']-=$info['send_num'];
                    $cgdinfo['send_status']=$cgdinfo['wsend_num']==0 ? 3:($cgdinfo['send_num']==0 ?1:2);
                    $cgdinfo['status']=$cgdinfo['wsend_num']==0 ? 3:($cgdinfo['send_num']==0 ?1:2);
                    $cgdinfo['updatetime']=date("Y-m-d H:i:s");
                    $up=Db::name("purchease_order")->save($cgdinfo);
                    if($up){
                        ActionLog::logAdd($this->post['token'],$order,"cgd", $cgdinfo['status'],$cgdinfo);
                        $process=["order_code"=>$info['cgdNo'],"order_id"=>$cgdinfo['id'],"order_status"=>$cgdinfo['status'],"order_type"=>'CGD'];
                        ProcessOrder::AddProcess($this->post['token'],$process);
                        Db::commit();
                        return app_show(0,'取消成功');
                    }else{
                        Db::rollback();
                        return error_show(1002,"取消失败");
                    }
                }
                if($status==1){
                    $cgdinfo=Db::name("purchease_order")->where(['cgdNo'=>$info['cgdNo'],"is_del"=>0])->find();
                    if(empty($cgdinfo)){
                        Db::rollback();
                        return error_show(1002,"未找到采购单数据");
                    }
                    $order = ["order_code"=>$info['cgdNo'],"status"=>$cgdinfo['status'],"action_remark"=>'',"action_type"=>"edit"];
                    $cgdinfo['wsend_num']-=$info['send_num'];
                    $cgdinfo['send_num']+=$info['send_num'];
                    $cgdinfo['send_status']=$cgdinfo['wsend_num']==0 ? 3:($cgdinfo['send_num']==0 ?1:2);
                    $cgdinfo['status']=$cgdinfo['wsend_num']==0 ? 3:($cgdinfo['send_num']==0 ?1:2);
                    $cgdinfo['updatetime']=date("Y-m-d H:i:s");
                    $up=Db::name("purchease_order")->save($cgdinfo);
                    if($up){
                        ActionLog::logAdd($this->post['token'],$order,"cgd", $cgdinfo['status'],$cgdinfo);
                        $process=["order_code"=>$info['cgdNo'],"order_id"=>$cgdinfo['id'],"order_status"=>$cgdinfo['status'],"order_type"=>'CGD'];
                        ProcessOrder::AddProcess($this->post['token'],$process);
                        Db::commit();
                        return app_show(0,'发货成功');
                    }else{
                        Db::rollback();
                        return error_show(1002,"发货失败");
                    }
                }
                if($status==4){
                    $cgdinfo=Db::name("purchease_order")->where(['cgdNo'=>$info['cgdNo'],"is_del"=>0])->find();
                    if(empty($cgdinfo)){
                        Db::rollback();
                        return error_show(1002,"未找到采购单数据");
                    }
                    $good = Db::name("good_stock")->where(["wsm_code"=>$info['wsm_code'], "spuCode"=>$cgdinfo['spuCode'],"is_del"=>0])->find();

                    if(empty($good)) {
                      $good=[
                          "spuCode"=>$cgdinfo['spuCode'],
                          "wsm_code"=>$info['wsm_code'],
                          "usable_stock"=>0,
                          "wait_out_stock"=>0,
                          "wait_in_stock"=>0,
                          "total_stock"=>0,
                          "addtime"=>date("Y-m-d H:i:s"),
                          "updatetime"=>date("Y-m-d H:i:s"),
                      ];
                        $order = ["order_code"=>$good['spuCode'],"status"=>1,"action_remark"=>'',
                            "action_type"=>"create"];

                    }else{
                        $order = ["order_code"=>$good['spuCode'],"status"=>1,"action_remark"=>'', "action_type"=>"edit"];
                    }
                    $good['usable_stock']+=$info['wsm_num'];
                    $good['wait_in_stock']-=$info['wsm_num'];
                    $good['total_stock']=$good['usable_stock']+$good['wait_out_stock'];
                    $good['updatetime'] = date("Y-m-d H:i:s");
                    $upd=  Db::name("good_stock")->save($good);
                    $good_data[]=["stock_id"=>isset($good['id'])? $good['id']:Db::name("good_stock")->getLastInsID(),"type"=>1,
                    'stock'=>$info['wsm_num'],"stock_name"=>"usable_stock"];
                    if($upd){
                        GoodLog::LogAdd($this->post['token'],$good_data,'入库单');
                        ActionLog::logAdd($this->post['token'],$order,"仓库库存", 1,$good  );
                        Db::commit();
                        return app_show(0,'商品入库成功');
                    }else{
                        Db::rollback();
                        return error_show(1002,"商品入库失败");
                    }
                }
                Db::commit();
                return app_show(0,"状态修改完成");
            }
           Db::rollback();
          return error_show(1002,"状态修改失败");

        }catch (\Exception $e){
            Db::rollback();
            return error_show(1002,$e->getMessage());
        }

    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function ReturnAdd(){
        $incode = isset($this->post['wsm_in_code'])&&$this->post['wsm_in_code']!="" ? trim($this->post['wsm_in_code']) :"";
        if($incode==""){
            return error_show(1004,"参数wsm_in_code 不为空");
        }
        $info = Db::name("purchease_in")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1004,"未找到数据");
        }
        $wsm_num = isset($this->post['wsm_num']) &&$this->post['wsm_num']!=="" ? intval($this->post['wsm_num']):"" ;
        if($wsm_num===""){
            return error_show(1004,"参数wsm_num 不为空");
        }
        $reissue_num = isset($this->post['reissue_num']) &&$this->post['reissue_num']!=="" ? intval($this->post['reissue_num']):"0" ;
        $return_num = isset($this->post['return_num']) &&$this->post['return_num']!=="" ? intval($this->post['return_num']):"0" ;
        $contactor = isset($this->post['contactor']) &&$this->post['contactor']!=="" ? trim($this->post['contactor']):"" ;
        if($contactor==""){
            return error_show(1004,"参数contactor 不为空");
        }
        $addr = isset($this->post['addr']) &&$this->post['addr']!=="" ? trim($this->post['addr']):"" ;
        if($addr==""){
            return error_show(1004,"参数addr 不为空");
        }
        $mobile = isset($this->post['mobile']) &&$this->post['mobile']!=="" ? trim($this->post['mobile']):"" ;
        if($mobile==""){
            return error_show(1004,"参数mobile 不为空");
        }
        $error_remark = isset($this->post['error_remark']) &&$this->post['error_remark']!=="" ? trim($this->post['error_remark']):"" ;
        $remark = isset($this->post['remark']) &&$this->post['remark']!=="" ? trim($this->post['remark']):"" ;
        $result = GetUserInfo($this->post['token']);
        if((!empty($result) && $result['code']!=0) ||empty($result) ){
            return error_show($result['code'],$result['message']);
        }
        $userinfo = $result['data'];
        Db::startTrans();
       try{

        $info['status'] =5;
        $info['is_th'] =$return_num>0 ?1:0;
        $info['updatetime'] = date("Y-m-d H:i:s");
        $up= Db::name("purchease_in")->save($info);
        if($up){
            $process=["order_code"=>$info['wsm_in_code'],"order_id"=>$info['id'],"order_status"=>$info['status'],"order_type"=>'RKD'];
            ProcessOrder::AddProcess($this->post['token'],$process);
            $data=[
                "wsm_in_code"=>$incode,
                "wsm_num"=>$wsm_num,
                "reissue_num"=>$reissue_num,
                "return_num"=>$return_num,
                "return_contactor"=>$contactor,
                "return_addr"=>$addr,
                "return_mobile"=>$mobile,
                "error_remark"=>$error_remark,
                "post_code"=>"",
                "post_company"=>"",
                "remark"=>$remark ,
                "apply_id"=>$userinfo['id'],
                "apply_name"=>$userinfo['nickname'],
                "status"=>0,
                "addtime"=>date("Y-m-d H:i:s"),
                "updatetime"=>date("Y-m-d H:i:s")
            ];
            $res = Db::name("purchease_return")->insert($data,true);
            if($res){
                $sto = ["order_code"=>$incode,"status"=>0,"action_remark"=>'',"action_type"=>"create"];
                ActionLog::logAdd($this->post['token'],$sto,"RKTHD",0,$sto);
                $process=["order_code"=>$info['wsm_in_code'],"order_id"=>$res,"order_status"=>0,"order_type"=>'RKTHD'];
                ProcessOrder::AddProcess($this->post['token'],$process);
                Db::commit();
                return app_show(0,"验货审核完成");
            }else{
                Db::rollback();
                return error_show(1002,"验货审核失败");
            }
        }
       }catch (\Exception $e){
           Db::rollback();
           return error_show(1002,$e->getMessage());
       }

    }

    public function ReturnSend(){
        $incode = isset($this->post['wsm_in_code'])&&$this->post['wsm_in_code']!="" ? trim($this->post['wsm_in_code']) :"";
        if($incode==""){
            return error_show(1004,"参数wsm_in_code 不为空");
        }
        $info = Db::name("purchease_in")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1004,"未找到发货单数据");
        }
        $return = Db::name("purchease_return")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
        if(empty($return)){
            return error_show(1004,"未找到退货单数据");
        }
        $post_code = isset($this->post['post_code']) &&$this->post['post_code']!=="" ? trim($this->post['post_code']):"" ;
        if($post_code==""){
            return error_show(1004,"参数 post_code 不能为空");
        }
        $post_company = isset($this->post['post_company']) &&$this->post['post_company']!=="" ? trim($this->post['post_company']):"" ;
        if($post_company==""){
            return error_show(1004,"参数 post_company 不能为空");
        }
        $remark = isset($this->post['remark']) &&$this->post['remark']!=="" ? trim($this->post['remark']):"" ;
        $data=[
            "post_code"=>$post_code,
            "post_company"=>$post_company,
            "remark"=>$remark,
            "status"=>1,
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        Db::startTrans();
        try{
            $up =Db::name("purchease_return")->where($return)->save($data);
            if($up){
                $sto = ["order_code"=>$info['wsm_in_code'],"status"=>1,"action_remark"=>'',"action_type"=>"edit"];
                ActionLog::logAdd($this->post['token'],$sto,"RKTHD",1,$sto);
                $process=["order_code"=>$info['wsm_in_code'],"order_id"=>$return['id'],"order_status"=>1,"order_type"=>'RKTHD'];
                ProcessOrder::AddProcess($this->post['token'],$process);
                $ark=$info['status'];
                $info['status']=6;
                $info['updatetime']=date("Y-m-d H:i:s");
                $sa=Db::name("purchease_in")->save($info);
                if($sa){
                    $stn = ["order_code"=>$info['wsm_in_code'],"status"=>$ark,"action_remark"=>'',"action_type"=>"edit"];
                    ActionLog::logAdd($this->post['token'],$stn,"RKD",5,$stn);
                    $process=["order_code"=>$info['wsm_in_code'],"order_id"=>$info['id'],"order_status"=>5,"order_type"=>'RKD'];
                    ProcessOrder::AddProcess($this->post['token'],$process);

                    Db::commit();
                    return  app_show(0,"退货发货成功");
                }else{
                    Db::rollback();
                    return  error_show(1004,"退货发货失败");
                }
            }else{
                return  error_show(1004,"退货发货失败");
            }
        }catch (\Exception $e){
            Db::rollback();
            return  error_show(1004,$e->getMessage());
        }

    }

//    public function ReturnStatus(){
//        $incode = isset($this->post['wsm_in_code'])&&$this->post['wsm_in_code']!="" ? trim($this->post['wsm_in_code']) :"";
//        if($incode==""){
//            return error_show(1004,"参数wsm_in_code 不为空");
//        }
//        $info = Db::name("purchease_in")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
//        if(empty($info)){
//            return error_show(1004,"未找到发货单数据");
//        }
//        $return = Db::name("purchease_return")->where(['wsm_in_code'=>$incode,"is_del"=>0])->find();
//        if(empty($return)){
//            return error_show(1004,"未找到数据");
//        }
//        if($info['status']<4){
//            return error_show(1004,"入库单未完成");
//        }
//        $status = isset($this->post['status'])&&$this->post['status']!="" ?$this->post['status']:"";
//        if($status==""){
//            return error_show(1004,"参数status 不为空");
//        }
//        Db::startTrans();
//        try{
//            $data=[
//                "status"=>$status,
//                "updatetime"=>date("Y-m-d H:i:s")
//            ];
//            $up =Db::name("purchease_return")->where($return)->save($data);
//            if($up){
//                    $info['status']=$status==1?5:6;
//                    $info['updatetime']=date("Y-m-d H:i:s");
//                    $sa=Db::name("purchease_in")->save($info);
//                    if($sa){
//                        Db::commit();
//                        return  app_show(0,"更新成功");
//                    }else{
//                        Db::rollback();
//                        return  error_show(1004,"更新失败");
//                    }
//            }else{
//                Db::rollback();
//                return  error_show(1004,"更新失败");
//            }
//        }catch (\Exception $e){
//            Db::rollback();
//            return  error_show(1004,$e->getMessage());
//        }
//
//    }
}